
package it.univr.test;

import it.univr.geometry.*;
import java.util.Arrays;

public class Main {

	public static void visualizza(Misurabile figuraGeometrica) {
	 	double perimetro = figuraGeometrica.getPerimetro();
		double area = figuraGeometrica.getArea();
		System.out.println("Perimetro: " + perimetro + ", area: " + area);
	}

	public static void main(String[] args) {
		Misurabile q1 = new Quadrato(2);
		Misurabile r1 = new Rettangolo(3,5);
		Misurabile c1 = new Cerchio (4);

		Quadrato q2 = new Quadrato(2);
		Rettangolo r2 = new Rettangolo(3,5);
		Cerchio c2 = new Cerchio (4);

	
		visualizza(q1);
		visualizza(r1);
		visualizza(c1);
		
		visualizza(q2);
		visualizza(r2);
		visualizza(c2);
		
		System.out.println(c1.getPerimetro());
		System.out.println(c2.getPerimetro());
		
		// System.out.println(c1.getCirconferenza());
		// l'invocazone a c1.getCirconferenza() sarebbe un errore perché il 
		// compilatore sa solo che c1 è di tipo Misurabile.
		// Se siamo sicuri che c1 è di tipo Cerchio, possiamo fare un cast.
		Cerchio c3 = (Cerchio) c1;
		System.out.println(c3.getCirconferenza());
		System.out.println(c2.getCirconferenza());
		
		Quadrabile q3 = (Quadrabile) q1;
		Quadrabile r3 = (Quadrabile) r1;
		visualizza(q3.getQuadratoEquivalente());
		visualizza(r3.getQuadratoEquivalente());

		Cerchio[] array = new Cerchio[4];
		array[0] = new Cerchio(4);
		array[1] = new Cerchio(2);
		array[2] = new Cerchio(3);
		array[3] = new Cerchio(1);
		
		Arrays.sort(array);
		
		System.out.println("\nCerchi ordinati:");
		for (Cerchio c : array)
			visualizza(c);
	}
	
}
